#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main (int argc, char **argv) 
{
  int s, port;
  struct sockaddr_in sin;

  if (argc != 3) {
    fprintf (stderr, "usage: %s ipserver port\n", argv[0]);
    return 1;
  }

  if ( (s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf (stderr, "Error \n");
    return 1;
  }

  bzero ((void *) &sin, sizeof (sin));

  sin.sin_family = AF_INET;

  inet_aton (argv[1], &(sin.sin_addr));
  port = atoi (argv[2]);
  if ((port < 65535) && (port > 0)) 
    sin.sin_port = htons ( (u_short) port);
  else {
    fprintf (stderr, "Error \n");
    close (s);
    return 1;
  }

  if ( (connect (s, (struct sockaddr *)&sin, sizeof (sin) )) == 0) {
    struct sockaddr_in myaddr;
    socklen_t len;

    bzero ((void *)&myaddr, sizeof (myaddr));

    len = sizeof (myaddr);
    if (getsockname(s, (struct sockaddr *)&myaddr, &len) == 0) 
      fprintf (stdout, "%s [%d] connect to %s [%d]\n", inet_ntoa (myaddr.sin_addr), ntohs (myaddr.sin_port), 
          inet_ntoa (sin.sin_addr), ntohs (sin.sin_port) );
    else {
      fprintf (stderr, "Error \n");
      close (s);
      return 1;
    }
  }
  else
    fprintf (stderr, "no connection\n");

  close (s);

  return 0;
}
