#include <stdio.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int main (int argc, char **argv) 
{
  int s, port;
  struct sockaddr_in sin;

  if (argc != 2) {
    fprintf (stderr, "usage: %s port \n", argv[0]);
    return 1;
  }

  if ( (s = socket (PF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf (stderr, "Error \n");
    return 1;
  }

  bzero ((void *) &sin, sizeof (sin));

  sin.sin_family = AF_INET;
  inet_aton ("127.0.0.1", &(sin.sin_addr));
  port = atoi (argv[1]);
  if ((port < 65535) && (port > 0)) 
    sin.sin_port = htons ( (u_short) port);
  else {
    fprintf (stderr, "Error \n");
    close (s);
    return 1;
  }

  if(bind(s, (struct sockaddr *) &sin, sizeof (sin)) != 0) {
    fprintf (stderr, "Error bind\n");
    return 1;
  }

  if (listen (s, 1) != 0) {
    fprintf (stderr, "Error listen\n");
    return 1;
  }

  while (1) {
    int ssock;
    socklen_t alen;
    struct sockaddr_in fin;

    bzero ((void *) &fin, sizeof (fin));
    alen = sizeof (fin);

    if ( (ssock = accept (s, (struct sockaddr *)&fin, &alen )) > 0) {
      fprintf (stdout, "accept from: %s [%d]\n", inet_ntoa (fin.sin_addr), ntohs (fin.sin_port) );
      close (ssock);
    }
    else {
      fprintf (stderr, "Error accept\n");
      close (s);
      return 1;
    }
  }

  close (s);

  return 0;
}
